--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
--% KMAPI                                        %
--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
--% Read the kmabc documentation if you want     %
--% to use the kmapi code to modify kmabc safely %
--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

import "QueekusPlugins.kmabc.options";

ColRbow = function() -- Custom rainbow colour scheme

	label:SetBackColor( Turbine.UI.Color(  1.0, 0.0, 0.0 ) ); --Red
	Save:SetBackColor( Turbine.UI.Color( 1.0, 0.5, 0.25 ) ); --Orange
	Load:SetBackColor( Turbine.UI.Color( 1.0, 1.0, 0.25 ) ); --Yellow
	Copywrite:SetBackColor( Turbine.UI.Color( 0.3, 0.3, 0.6 ) ); --Violet

	label1:SetBackColor( Turbine.UI.Color( 1.0, 0.0, 0.0 ) ); --Red
	label2:SetBackColor( Turbine.UI.Color( 1.0, 0.5, 0.25 ) ); --Orange

	quickslot1:SetBackColor( Turbine.UI.Color( 1.0, 0.0, 0.0 ) ); --Red
	quickslot2:SetBackColor( Turbine.UI.Color( 1.0, 0.5, 0.25 ) ); --Orange
	quickslot3:SetBackColor( Turbine.UI.Color( 1.0, 1.0, 0.25 ) ); --Yellow
	quickslot4:SetBackColor( Turbine.UI.Color( 0.0, 1.0, 0.0 ) ); --Green
	quickslot5:SetBackColor( Turbine.UI.Color( 0.0, 0.0, 1.0 ) ); --Blue
	quickslot6:SetBackColor( Turbine.UI.Color( 0.5, 0.0, 0.5 ) ); --Indigo
	quickslot7:SetBackColor( Turbine.UI.Color( 0.3, 0.3, 0.6 ) ); --Violet

	quickslot8:SetBackColor( Turbine.UI.Color( 1.0, 0.0, 0.0 ) ); --Red
	quickslot9:SetBackColor( Turbine.UI.Color( 1.0, 0.5, 0.25 ) ); --Orange
	quickslotlyrical:SetBackColor( Turbine.UI.Color( 1.0, 1.0, 0.25 ) ); --Yellow

	quickslotSP:SetBackColor( Turbine.UI.Color( 0.5, 0.0, 0.5 ) ); --Indigo
	quickslotPS:SetBackColor( Turbine.UI.Color(  0.3, 0.3, 0.6 ) ); --Violet
	quickslotP:SetBackColor( Turbine.UI.Color( 0.0, 0.0, 1.0 ) ); --Blue
	quickslotMM:SetBackColor( Turbine.UI.Color( 0.0, 1.0, 0.0 ) ); --Green

	compactQuicks:SetBackColor( Turbine.UI.Color( 1.0, 1.0, 0.25 ) ); --Yellow

	Notes:SetBackColor( Turbine.UI.Color( 0.5, 0.0, 0.5 ) ); --Indigo

	compactcontrol:SetBackColor( Turbine.UI.Color( 1.0, 1.0, 0.25 ) ); --Yellow
	musicIcon:SetBackColor( Turbine.UI.Color(  0.0, 1.0, 0.0 ) ); --Green
	playIcon:SetBackColor( Turbine.UI.Color(  0.0, 0.0, 1.0 ) ); --Blue
	PlaySyncIcon:SetBackColor( Turbine.UI.Color(  0.5, 0.0, 0.5 ) ); --Indigo
	PlayStartIcon:SetBackColor( Turbine.UI.Color(  0.3, 0.3, 0.6 ) ); --Violet

	LyricalIcon:SetBackColor( Turbine.UI.Color(  1.0, 1.0, 0.25 ) ); --Yellow

	PlistName:SetBackColor( Turbine.UI.Color( 0.0, 1.0, 0.0) );

	listbox:SetBackColor( Turbine.UI.Color( 1.0, 0.0, 0.0 ) );

	for i=1, listbox:GetItemCount() do

		local currentItem = listbox:GetItem(i);  
		currentItem:SetBackColor( Turbine.UI.Color( math.random(), math.random(), math.random() ) );

	end

	currColour.R = r;
	currColour.G = g;
	currColour.B = b;

end

doColour = function (nR, nG, nB, r, g, b, rShift, gShift, bShift) -- normal doColour routine

	Notes:SetBackColor( Turbine.UI.Color( nR, nG, nB ) ); 

	label:SetBackColor( Turbine.UI.Color(  r, g, b ) );
	Save:SetBackColor( Turbine.UI.Color( r, g, b ) );
	Load:SetBackColor( Turbine.UI.Color( r, g, b ) );
	Copywrite:SetBackColor( Turbine.UI.Color( r, g, b ) );
	label1:SetBackColor( Turbine.UI.Color( r, g, b ) );
	label2:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot1:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot2:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot3:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot4:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot5:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot6:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot7:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot8:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslot9:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslotlyrical:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslotSP:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslotPS:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslotP:SetBackColor( Turbine.UI.Color( r, g, b ) );
	quickslotMM:SetBackColor( Turbine.UI.Color( r, g, b ) );
	compactQuicks:SetBackColor( Turbine.UI.Color( r, g, b ) );

	compactcontrol:SetBackColor( Turbine.UI.Color( rShift,  gShift,  bShift ) );
	musicIcon:SetBackColor( Turbine.UI.Color( rShift,  gShift, bShift ) );
	playIcon:SetBackColor( Turbine.UI.Color( rShift,  gShift, bShift ) );
	PlaySyncIcon:SetBackColor( Turbine.UI.Color( rShift,  gShift, bShift ) );
	PlayStartIcon:SetBackColor( Turbine.UI.Color( rShift,  gShift, bShift ) );
	LyricalIcon:SetBackColor( Turbine.UI.Color(  rShift,  gShift, bShift ) );

	PlistName:SetBackColor( Turbine.UI.Color( r, g, b ) );

	listbox:SetBackColor( Turbine.UI.Color( r, g, b ) );

	for i=1, listbox:GetItemCount() do

		local currentItem = listbox:GetItem(i);  
		currentItem:SetBackColor( Turbine.UI.Color( r, g, b ) );

	end

	currColour.R = r;
	currColour.G = g;
	currColour.B = b;

end

kmapi = {
		addToTable = function(boxName, stringName, doThis) 
			-- Create Item
			listItem = Turbine.UI.Label()

			-- Set its statistics
			listItem:SetSize( 150, 15 );
			listItem:SetBackColor( Turbine.UI.Color(  0.2, 0.2, 0.2 ) );
			listItem:SetText( ""..stringName );
			listItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
			listItem:SetForeColor( Turbine.UI.Color(  1.0, 1.0, 1.0 ) );

			-- Add to listbox specified

			if boxName == "colour" then


				if doThis == nil then
					
					if stringName == ""..P38 then

							listItem:SetForeColor( Turbine.UI.Color(  0.5, 1.0, 1.0 ) );

					end

					if stringName == ""..P42 then

							listItem:SetForeColor( Turbine.UI.Color(  1.0, 0.5, 1.0 ) );
							listItem:SetSize( 150, 45 );

					end

					listItem.MouseClick = function(sender , args)

						if stringName == "Rainbow" then

							ColRbow()

						end
										
					end

				else
					
					listItem.MouseClick = function(sender , args)

							doColour( doThis[1], doThis[2], doThis[3], doThis[4], doThis[5], doThis[6], doThis[7], doThis[8], doThis[9] )
							
					end
					

				end
				
				ColourLBox:AddItem( listItem );

			elseif boxName == "language" then

				if doThis == nil then
					
					if stringName == ""..P39 then

							listItem:SetForeColor( Turbine.UI.Color(  0.5, 1.0, 1.0 ) );

					end

					if stringName == ""..P23 then

							listItem:SetForeColor( Turbine.UI.Color(  1.0, 0.5, 1.0 ) );
							listItem:SetSize( 150, 60 );

					end

				else
					
					listItem.MouseClick = function(sender , args)

						i = doThis
						
						language(i)
						UdateScreen()
						optLang(i)
						
						Load.Click()
					end
					

				end

				LanguageLBox:AddItem( listItem );

			else

				Turbine.Shell.WriteLine("Listbox Specified Is Not Valid: "..boxName)

			end

			
		end,

		isTrue = function(t) 
	
			if ( t == true ) then

				return "true"

			else

				return "false"

			end
		end,

		console = {
				text = function(text) 
		
					Turbine.Shell.WriteLine(""..text);
				end



		}

	
	};
